/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pismena;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.SortedMap;
import java.util.SortedSet;
import java.util.TreeMap;
import java.util.TreeSet;

/**
 *
 * @author petr
 */
public class Frekvence {

    Map<Character, Integer> pismena;
    int count = 0;
    List<NumberCount> result;

    public void analyze(URL file, String charsetName) throws IOException {

        InputStreamReader reader = new InputStreamReader(new BufferedInputStream(file.openStream()), charsetName);
        pismena = new HashMap<Character, Integer>();

        int c;
        char ch;
        do {
            c = reader.read();
            if (c < 0) {
                break;
            }
            ch = (char) c;
            if (Character.isWhitespace(ch)) {
                continue;
            }
            count++;
            ch = Character.toLowerCase(ch);

            if (pismena.containsKey(ch)) {
                int sum = pismena.get(ch) + 1;
                pismena.put(ch, sum);
            } else {
                pismena.put(ch, 1);
            }

        } while (true);

        result = new ArrayList<NumberCount>(pismena.size());
        for(Entry<Character,Integer> entry: pismena.entrySet()) {
            result.add(new NumberCount(entry.getKey(),entry.getValue()));
        }
        Collections.sort(result,Collections.reverseOrder());
    }
    public List<NumberCount> getResult(int count) {
        return result.subList(0, result.size() > count ? count : result.size()-1);
    }

    public int getCount() {
        return count;
    }
}
